function love.load(arg)
	state = "instructions"
	paused = false -- pretty much useless atm
	time = 0
	ply1 = {}
	ply1.times = 0 -- doesn't have anything to do with time
	ply1.lives = 3
	ply2 = {}
	ply2.times = 0
	ply2.lives = 3
	tiledChars = require("font") -- not actually a font - duh
	liveChars = {}
	local x = true
	liveChars["1"] = {{s,x,x},{x,s,s,x},{x,s,s,x},{s,x,x}}
	liveChars["2"] = {{s,x,x},{x,s,s,x},{x,s,s,x},{s,x,x},{},{s,x,x},{x,s,s,x},{x,s,s,x},{s,x,x}}
	liveChars["3"] = {{s,x,x},{x,s,s,x},{x,s,s,x},{s,x,x},{},{s,x,x},{x,s,s,x},{x,s,s,x},{s,x,x},{},{s,x,x},{x,s,s,x},{x,s,s,x},{s,x,x}}
	-- ^ ugly, ugly stuff, don't let your kids see this
	
	-- control settings
	ply1.keys = {"q", "w", "e", "r", "a", "s", "d", "f"}
	ply2.keys = {"u", "i", "o", "p", "h", "j", "k", "l"}
	ply1.key = ply1.keys[math.random(1, #ply1.keys)]
	ply2.key = ply2.keys[math.random(1, #ply2.keys)]
	continuekey = "g"
end

function love.draw() -- rendering everything - ignore this part if you want to stay sane
	love.graphics.scale(8)
	love.graphics.setColor(255, 127, 0)
	drawTiledChar(liveChars, tostring(ply1.lives), 0, 0)
	love.graphics.setColor(255, 255, 255)
	drawTiledString(tiledChars, string.sub("0"..ply1.times, -2), 5, 7)
	drawTiledString(tiledChars, string.sub("0"..ply2.times, -2), 19, 7)
	love.graphics.setColor(0, 255, 0)
	drawTiledChar(tiledChars, "|", 17, 7)
	love.graphics.setColor(0, 127, 255)
	drawTiledChar(liveChars, tostring(ply2.lives), 31, 0)
	love.graphics.setColor(math.random(0, 255), math.random(0, 255), math.random(0, 255))
	drawTiledChar(tiledChars, string.upper(ply1.key), 5, 0)
	love.graphics.setColor(math.random(0, 255), math.random(0, 255), math.random(0, 255))
	drawTiledChar(tiledChars, string.upper(ply2.key), 25, 0)
	
	
	-- draw overlays
	if state == "instructions" then
	  
		love.graphics.setColor(0, 0, 0, 240)
		love.graphics.rectangle("fill", 0, 0, 35, 14)
		love.graphics.setColor(0, 255, 0)
		local w, h = drawTiledString(tiledChars, string.upper(continuekey), 0.25, 10.25, 0.5)
		love.graphics.setColor(255, 255, 255)
		drawTiledString(tiledChars, "INSTRUCTIONS:", 0.25, 0.25, 0.5)
		drawTiledString(tiledChars, ": GO", 0.25 + (w+2)/2, 10.25, 0.5)
		drawTiledString(tiledChars, "Press your key.", 0.25, 5.25, 0.5)
-- 		love.graphics.setColor(255, 127, 0)
-- 		drawTiledString(tiledChars, "P1: " .. string.upper(ply1.key), 0.25, 5.25, 0.5)
-- 		love.graphics.setColor(0, 127, 255)
-- 		drawTiledString(tiledChars, "P2: " .. string.upper(ply2.key), 22.75, 5.25, 0.5)
		
	elseif state == "playing" then
	  
		if time <3 then -- big green countdown that counts from 3 to 1
			local t = 3 - (math.floor(time))
			love.graphics.setColor(0, 0, 0, 240)
			love.graphics.rectangle("fill", 0, 0, 35, 14)
			love.graphics.setColor(0, 255, 0)
			drawTiledChar(tiledChars, tostring(t), 12.5, 0, 2)
		else -- little red timer that counts down to 0 from 5
			local str = string.sub(tostring(math.ceil((5 - time + 3)*10)/10)..".0", 1, 3)
			love.graphics.setColor(255, 0, 0)
			drawTiledString(tiledChars, str, 11, 0)
		end
		
	elseif state == "results" then
	  
		love.graphics.setColor(0, 0, 0, 240)
		love.graphics.rectangle("fill", 0, 0, 35, 14)
		if ply1.times > ply2.times then
			love.graphics.setColor(255, 127, 0)
			drawTiledString(tiledChars, "P1 won!", 0.5, 3)
		elseif ply1.times < ply2.times then
			love.graphics.setColor(0, 127, 255)
			drawTiledString(tiledChars, "P2 won!", 0.5, 3)
		else
			love.graphics.setColor(255, 255, 255)
			drawTiledString(tiledChars, "Draw!", 7, 3)
		end
		
	elseif state == "game over" then
	  
		love.graphics.setColor(0, 0, 0, 255)
		love.graphics.rectangle("fill", 0, 0, 35, 14)
		love.graphics.setColor(255, 255, 255)
		drawTiledString(tiledChars, "GAME OVER", 0.25, 0.25, 0.5)
		if ply1.lives > ply2.lives then
			love.graphics.setColor(255, 127, 0)
			drawTiledString(tiledChars, "P1 won!", 0.5, 5.5)
		elseif ply1.lives < ply2.lives then
			love.graphics.setColor(0, 127, 255)
			drawTiledString(tiledChars, "P2 won!", 0.5, 5.5)
		end
		
	end
	
	if paused then -- paused overlay
		love.graphics.setColor(0, 0, 0, 240)
		love.graphics.rectangle("fill", 0, 0, 35, 14)
		love.graphics.setColor(255, 255, 255)
		drawTiledString(tiledChars, "Paused", 3, 3)
	end
end

function love.update(dt)
	if paused then return end -- make sure no game logic is happening when paused
	
	time = time + dt
	if time > 8 and state == "playing" then -- 8 = 3 (initial countdown) + 5 (the time you actually play)
		if ply1.times > ply2.times then
			ply2.lives = ply2.lives - 1
		elseif ply1.times < ply2.times then
			ply1.lives = ply1.lives - 1
		end
		if ply1.lives <= 0 or ply2.lives <= 0 then
			state = "game over"
		else
			state = "results"
		end
	end
end

function love.keypressed(key, isrepeat)
	if key == "escape" then love.event.quit() end -- stops the game when you press escape
	
	if state == "instructions" then
		if key == continuekey then
			state = "playing"
			time = 0
		end
	elseif state == "playing" then
		if time >= 3 then
			if key == ply1.key then
				ply1.times = ply1.times + 1
				ply1.key = ply1.keys[math.random(1, #ply1.keys)]
			elseif key == ply2.key then
				ply2.times = ply2.times + 1
				ply2.key = ply2.keys[math.random(1, #ply2.keys)]
			end
		end
	elseif state == "results" then
		if key == continuekey then
			state = "playing"
			ply1.key = ply1.keys[math.random(1, #ply1.keys)]
			ply2.key = ply2.keys[math.random(1, #ply2.keys)]
			ply1.times = 0
			ply2.times = 0
			time = 0
		end
	elseif state == "game over" then
		if key == continuekey then
			state = "instructions" -- change this to "playing" if you want
			ply1.lives = 3
			ply1.times = 0
			ply2.lives = 3
			ply2.times = 0
			time = 0 -- don't need that here but too lazy to remove :P (I just typed this comment instead...)
		end
	end
end

function drawTiledChar(charlist, char, x, y, scale)
	if not charlist[char] then return 0, 0 end
	scale = scale or 1
	local width = 0
	for my, chy in pairs(charlist[char]) do
		width = math.max(width, #chy)
		for mx, bool in pairs(chy) do
			if bool then -- bool probably is not a boolean...
				love.graphics.rectangle("fill", x + (mx-1)*scale, y + (my-1)*scale, scale, scale)
			end
		end
	end
	return width, #charlist[char] -- returns width and height (pixels in character). To get the actual value, multiply by scale.
end

function drawTiledString(charlist, str, x, y, scale) -- does not account for "\n" etc. - everything in one line
	if not charlist then return 0, 0 end
	local width, height = 0, 0
	scale = scale or 1
	for char in string.gmatch(str, ".") do
		dx, dy = drawTiledChar(charlist, char, x + width*scale, y, scale)
		width = width + dx + 1
		height = math.max(height, dy)
	end
	width = width - 1
	return width, height -- returns width and height (pixels in character). To get the actual value, multiply by scale.
end

function love.focus(f)
	paused = not f
end



--[[--
These are all the callback functions I didn't use.

function love.errhand(msg) end
function love.gamepadaxis(joystick, axis, value) end
function love.gamepadpressed(joystick, button) end
function love.gamepadreleased(joystick, button) end
function love.joystickadded(joystick) end
function love.joystickaxis(joystick, axis, value) end
function love.joystickhat(joystick, hat, direction) end
function love.joystickpressed(joystick, button) end
function love.joystickreleased(joystick, button) end
function love.joystickremoved(joystick) end
function love.keyreleased(key) end
function love.mousefocus(f) end
function love.mousemoved(x, y, dx, dy) end
function love.mousepressed(x, y, button) end
function love.mousereleased(x, y, button) end
function love.quit() end
function love.resize(w, h) end
function love.run() end
function love.textinput(text) end
function love.threaderror(thread, errorstr) end
function love.visible(v) end
--]]--